<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>KerberosUtil.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.util</a> &gt; <span class="el_source">KerberosUtil.java</span></div><h1>KerberosUtil.java</h1><pre class="source lang-java linenums">/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.util;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

<span class="nc" id="L24">public class KerberosUtil {</span>

  public static String getDefaultRealm() 
      throws ClassNotFoundException, NoSuchMethodException, 
      IllegalArgumentException, IllegalAccessException, 
      InvocationTargetException {
    Object kerbConf;
    Class&lt;?&gt; classRef;
    Method getInstanceMethod;
    Method getDefaultRealmMethod;
<span class="pc bpc" id="L34" title="1 of 2 branches missed.">    if (System.getProperty(&quot;java.vendor&quot;).contains(&quot;IBM&quot;)) {</span>
<span class="nc" id="L35">      classRef = Class.forName(&quot;com.ibm.security.krb5.internal.Config&quot;);</span>
    } else {
<span class="fc" id="L37">      classRef = Class.forName(&quot;sun.security.krb5.Config&quot;);</span>
    }
<span class="fc" id="L39">    getInstanceMethod = classRef.getMethod(&quot;getInstance&quot;, new Class[0]);</span>
<span class="fc" id="L40">    kerbConf = getInstanceMethod.invoke(classRef, new Object[0]);</span>
<span class="fc" id="L41">    getDefaultRealmMethod = classRef.getDeclaredMethod(&quot;getDefaultRealm&quot;,</span>
         new Class[0]);
<span class="nc" id="L43">    return (String)getDefaultRealmMethod.invoke(kerbConf, new Object[0]);</span>
  }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>